# <p align="center"> AndroidGuide </p>

<p align="center">Android Developer 进阶学习笔记，希望对你有所帮助 😃😃😃</p>

<p align="center">欢迎关注公众号，第一时间看最新文章</p>

# <p align="center"><a href=https://github.com/leavesCZY/leavesCZY/assets/30774063/c6310f5d-5047-45ed-86ba-0ab5685e40fc>字节数组</a></p>

<div align=center><img src ="https://github.com/leavesCZY/leavesCZY/assets/30774063/c6310f5d-5047-45ed-86ba-0ab5685e40fc"/></div>

<p align="center"></p>

<p align="center">原创不易，讨口饭吃 😆😆😆</p>

<p align="center"></p>

<div align=center><img src ="https://github.com/leavesCZY/AndroidGuide/assets/30774063/48974bd7-c602-427f-a4bc-3fdb0718d550"/></div>


- 个人开源库
  - [Trace：一个 Android 字节码插桩库](https://github.com/leavesCZY/Trace)
  - [Matisse：一个用 Jetpack Compose 实现的 Android 图片/视频 选择框架](https://github.com/leavesCZY/Matisse)
  - [Monitor：一个适用于 OkHttp / Retrofit 的可视化抓包工具](https://github.com/leavesCZY/Monitor)
  - [compose_chat：Jetpack Compose 最佳实践，用 Jetpack Compose 写一个 IM APP](https://github.com/leavesCZY/compose_chat)
  - [compose_tetris：不止 Android，用 Compose Multiplatform 实现一个 Android + Desktop 平台的俄罗斯方块](https://github.com/leavesCZY/compose_tetris)
  - [asm-samples：Android 字节码插桩实战](https://github.com/leavesCZY/asm-samples)
  - [KVHolder：一个基于 Kotlin 语法对 MMKV 进行封装的 key-value 存储库，简化了 MMKV 的使用步骤](https://github.com/leavesCZY/KVHolder)  
  - [RobustWebView：Android WebView H5 秒开方案总结](https://github.com/leavesCZY/RobustWebView)
  - [SmallestWidthGenerator：基于 SmallestWidth 屏幕适配方案生成 dimens 文件](https://github.com/leavesCZY/SmallestWidthGenerator)
  - [EventLiveData：Jetpack LiveData 功能扩展](https://github.com/leavesCZY/EventLiveData)

- Android
  - [App 出海实践：Google Play 结算系统](https://juejin.cn/post/7271991667245744165)
  - [推荐几个开源项目，也许对你有所帮助](https://juejin.cn/post/7256386855720976443)
  - [Android 13 媒体权限适配指南](https://juejin.cn/post/7159999910748618766)
  - [Android WebView H5 秒开方案总结](https://juejin.cn/post/7016883220025180191)
  - [Jetpack LiveData 的设计理念及改进](https://juejin.cn/post/6903096576734920717)
  - [Coil 和 Glide 的 Bitmap 缓存复用机制](https://juejin.cn/post/6956090846470995975)
  - [探究 Bitmap 的优化手段](https://juejin.cn/post/6952429810207424526)
  - [聊聊 Context 的一些知识点](https://juejin.cn/post/6966223613057826852)
  - [一文读懂 Handler 机制](https://juejin.cn/post/6901682664617705485)
  - [一文读懂 Android 主流屏幕适配方案](https://juejin.cn/post/6999445137491230728)
  - [一文读懂 Activity 的启动模式](https://juejin.cn/post/6952886121328345101)
  - [一文读懂 Fragment 的方方面面](https://juejin.cn/post/7006970844542926855)
  - [一文读懂 Java 和 Kotlin 的泛型难点](https://juejin.cn/post/6935322686943920159)
  - [一文读懂 SharedPreferences 的缺陷及一点点思考](https://juejin.cn/post/6932277268110639112)
  - [一文读懂 View 事件分发机制](https://juejin.cn/post/6931914294980411406)
  - [一文读懂 View & Window 机制](https://juejin.cn/post/6942303848996274213)
  - [一文读懂 View 的 Measure、Layout、Draw 流程](https://juejin.cn/post/6939540905581887502)
  - [一文读懂 View Post 的原理及缺陷](https://juejin.cn/post/6939763855216082974)
  - [一文快速入门 Kotlin 协程](https://juejin.cn/post/6908271959381901325)
  - [一文快速入门 ConstraintLayout](https://juejin.cn/post/6911710012750430215)
  - [一文快速入门 Gson](https://juejin.cn/post/6844903577098387464)
  - [一文快速入门 RxJava2](https://github.com/leavesCZY/AndroidGuide/blob/master/android_core/一文快速入门RxJava2.md)
  - [一文快速入门 Dagger2](https://github.com/leavesCZY/Dagger2Samples)
  - [一文快速入门 DataBinding](https://github.com/leavesCZY/DataBindingSamples)
  - [一文快速入门 APT](https://juejin.cn/post/6844903753108160525)

- 字节码插桩
  - [ASM 字节码插桩：实现双击防抖](https://juejin.cn/post/7042328862872567838)
  - [ASM 字节码插桩：进行线程整治](https://juejin.cn/post/7043999874076901406)
  - [ASM 字节码插桩：助力隐私合规](https://juejin.cn/post/7046207125785149448)
  - [ASM 字节码插桩：监控大图加载](https://juejin.cn/post/7074970389188706318)
  - [ASM 字节码插桩：从 Lambda 表达式讲起](https://juejin.cn/post/7151798531672506398)
  - [ASM 字节码插桩：Jetpack Compose 实现双击防抖](https://juejin.cn/post/7158061389503250445)
  - [Android 字节码插桩库，也许有你需要的](https://juejin.cn/post/7261599630826635320)

- Jetpack 源码解析
  - [Jetpack LiveData 的设计理念及改进](https://juejin.cn/post/6903096576734920717)
  - [从源码看 Jetpack（一）- Lifecycle 源码详解](https://juejin.cn/post/6847902220755992589)
  - [从源码看 Jetpack（二）- Lifecycle 衍生物源码详解](https://juejin.cn/post/6847902220760203277)
  - [从源码看 Jetpack（三）- LiveData 源码详解](https://juejin.cn/post/6847902222345633806)
  - [从源码看 Jetpack（四）- LiveData 衍生物源码详解](https://juejin.cn/post/6847902222353858567)
  - [从源码看 Jetpack（五）- Startup 源码详解](https://juejin.cn/post/6847902224069165070)
  - [从源码看 Jetpack（六）- ViewModel 源码详解](https://juejin.cn/post/6873356946896846856)
  - [从源码看 Jetpack（七）- SavedStateHandle 源码详解](https://juejin.cn/post/6874136956347875342)

- Jetpack Compose
  - [不止 Android，Compose Multiplatform 初探](https://juejin.cn/post/7062533562460799013)  
  - [随便嵌套？Jetpack Compose 到底优秀在哪里](https://juejin.cn/post/7070158120831418381)
  - [Jetpack Compose 实现完美屏幕适配](https://juejin.cn/post/7113953940282015758)  
  - [Jetpack Compose 写一个图片选择框架](https://juejin.cn/post/7108420791502372895)
  - [Jetpack Compose 写一个 BottomSheetDialog](https://juejin.cn/post/7151792921698631717)
  - [学不动也要学，Jetpack Compose 写一个 IM APP（一）](https://juejin.cn/post/6991429231821684773)
  - [学不动也要学，Jetpack Compose 写一个 IM APP（二）](https://juejin.cn/post/7028397244894330917)
  - [学不动也要学，Jetpack Compose 写一个俄罗斯方块](https://juejin.cn/post/6974585048762679310)
  - [学不动也要学，Jetpack Compose 实现自定义绘制](https://juejin.cn/post/6996568363581308959)

- Kotlin
  - [两万六千字带你 Kotlin 入门](https://juejin.cn/post/6880602489297895438)
  - [一文快速入门 Kotlin 协程](https://juejin.cn/post/6908271959381901325)  
  - [一文读懂 Java 和 Kotlin 的泛型难点](https://juejin.cn/post/6935322686943920159)
  - [Gson 和 Kotlin Data Class 的避坑指南](https://juejin.cn/post/6908391430977224718)
  - [探究 Kotlin 的隐藏性能开销与避坑指南](https://juejin.cn/post/7010367024916660237)
  - [【译】kotlin 协程官方文档（一）- 协程基础](https://juejin.cn/post/6844903972755472391)
  - [【译】kotlin 协程官方文档（二）- 取消和超时](https://juejin.cn/post/6844904098899181582)
  - [【译】kotlin 协程官方文档（三）- 组合挂起函数](https://juejin.cn/post/6844904100102930445)
  - [【译】kotlin 协程官方文档（四）- 协程上下文和调度器](https://juejin.cn/post/6844904100103094280)
  - [【译】kotlin 协程官方文档（五）- 异步流](https://juejin.cn/post/6844904101801639949)
  - [【译】kotlin 协程官方文档（六）- 通道](https://juejin.cn/post/6844904102040698893)
  - [【译】kotlin 协程官方文档（七）- 异常处理](https://juejin.cn/post/6844904103080886285)
  - [【译】kotlin 协程官方文档（八）- 共享可变状态和并发性](https://juejin.cn/post/6844904104053964808)
  - [【译】kotlin 协程官方文档（九）- 选择表达式](https://juejin.cn/post/6844904106788667400)

- 开源库源码解析
  - [Android 主流开源库源码分析（一）- EventBus 源码详解](https://juejin.cn/post/6881265680465788936)
  - [Android 主流开源库源码分析（二）- EventBus 自己实现一个](https://juejin.cn/post/6881808026647396366)
  - [Android 主流开源库源码分析（三）- ARouter 源码详解](https://juejin.cn/post/6882553066285957134)
  - [Android 主流开源库源码分析（四）- ARouter 自己实现一个](https://juejin.cn/post/6882553066285957134)
  - [Android 主流开源库源码分析（五）- LeakCanary 源码详解](https://juejin.cn/post/6884225131015569421)
  - [Android 主流开源库源码分析（六）- LeakCanary 扩展阅读](https://juejin.cn/post/6884526739646185479)
  - [Android 主流开源库源码分析（七）- Retrofit 源码详解](https://juejin.cn/post/6886121327845965838)
  - [Android 主流开源库源码分析（八）- Retrofit 与 LiveData 的结合使用](https://juejin.cn/post/6887408273213882375)
  - [Android 主流开源库源码分析（九）- Glide 源码详解](https://juejin.cn/post/6891307560557608967)
  - [Android 主流开源库源码分析（十）- Glide 你可能不知道的知识点](https://juejin.cn/post/6892751013544263687)
  - [Android 主流开源库源码分析（十一）- OkHttp 源码详解](https://juejin.cn/post/6895369745445748749)
  - [Android 主流开源库源码分析（十二）- OkHttp / Retrofit 开发调试利器](https://juejin.cn/post/6895740949025177607)
  - [Android 主流开源库源码分析（十三）- 可能是全网第一篇 Coil 源码分析文章](https://juejin.cn/post/6897872882051842061)

- 集合框架源码解析
  - [Java & Android 集合框架须知须会（一）](https://juejin.cn/post/6901317365561032712)
  - [Java & Android 集合框架须知须会（二）](https://juejin.cn/post/6931007634028003341)
  - [Java & Android 集合框架须知须会（三）](https://juejin.cn/post/6931563785245163534)

- 多线程编程
  - [Java 多线程编程（一）- 什么是多线程](https://juejin.cn/post/6899452217528025095)
  - [Java 多线程编程（二）- 怎么实现多线程同步](https://juejin.cn/post/6900428838497419278)
  - [Java 多线程编程（三）- 线程活性故障有哪些](https://juejin.cn/post/6900458045197778952)
  - [Java 多线程编程（四）- 锁的分类有这么多](https://juejin.cn/post/6900958860454920205)
  - [Java 多线程编程（五）- 超详细的 ThreadPoolExecutor 源码解析](https://juejin.cn/post/6901317365561032712)
